# Detect the distribution in use
%global __despace head -n 1 | tr -d '[:space:]' | sed -e 's/[(].*[)]//g'
%global __lower4 cut -c 1-4 | tr '[:upper:]' '[:lower:]'
%global __distfile %([ -f /etc/SuSE-release ] && echo /etc/SuSE-release || echo /etc/redhat-release)
%global __distinit %(sed -e 's/ release .*//' -e 's/\\([A-Za-z]\\)[^ ]*/\\1/g' %{__distfile} | %{__despace} | %{__lower4})
%global __distvers %(sed -e 's/.* release \\([^. ]*\\).*/\\1/' %{__distfile} | %{__despace})
# Identify CentOS Linux and Scientific Linux as rhel
%if "%{__distinit}" == "c" || "%{__distinit}" == "cl" || "%{__distinit}" == "sl" || "%{__distinit}" == "sls"
%global __distinit rhel
%endif
# Dist tag for Fedora is still "fc"
%if "%{__distinit}" == "f"
%global __distinit fc
%endif

%bcond_with network_tests

Name:		perl-MetaCPAN-API-Tiny
Version:	1.150270
Release:	9.%{__distinit}%{__distvers}
Summary:	A Tiny API client for MetaCPAN
License:	GPL+ or Artistic
URL:		https://metacpan.org/release/MetaCPAN-API-Tiny
Source0:	http://cpan.metacpan.org/authors/id/J/JL/JLUIS/MetaCPAN-API-Tiny-%{version}.tar.gz
BuildArch:	noarch
# Build
BuildRequires:	coreutils
BuildRequires:	findutils
BuildRequires:	make
BuildRequires:	perl-generators
BuildRequires:	perl-interpreter
BuildRequires:	perl(ExtUtils::MakeMaker)
# Module
BuildRequires:	perl(Carp)
BuildRequires:	perl(HTTP::Tiny) >= 0.017
BuildRequires:	perl(JSON::PP)
BuildRequires:	perl(strict)
BuildRequires:	perl(warnings)
# Test suite
BuildRequires:	perl(Exporter) >= 5.57
BuildRequires:	perl(Test::More)
# Author/Release tests
BuildRequires:	perl(Test::Pod) >= 1.41
# Runtime
Requires:	perl(:MODULE_COMPAT_%(eval "`perl -V:version`"; echo $version))

%description
This is the Tiny version of MetaCPAN::API. It implements a compatible API with
a few notable exceptions:

Attributes are direct hash access

 * The attributes defined using Mo(o|u)se are now accessed via the blessed hash
   directly. There are no accessors defined to access these elements.

Exception handling

 * Instead of using Try::Tiny, raw evals are used. This could potentially cause
   issues, so just be aware.

Testing

 * Test::Fatal was replaced with an eval implementation of exception().
   Test::TinyMocker usage is retained, but may be absorbed since it is pure
   perl.

%prep
%setup -q -n MetaCPAN-API-Tiny-%{version}

%build
perl Makefile.PL INSTALLDIRS=vendor
make %{?_smp_mflags}

%install
make pure_install DESTDIR=%{buildroot}
find %{buildroot} -type f -name .packlist -delete
%{_fixperms} -c %{buildroot}

%check
%if !%{with network_tests}
mv t/{author,module,pod,release,source}.t ./
%endif

make test RELEASE_TESTING=1

%if !%{with network_tests}
mv ./{author,module,pod,release,source}.t t/
%endif

%files
%if 0%{?_licensedir:1}
%license LICENSE
%else
%doc LICENSE
%endif
%doc Changes README
%{perl_vendorlib}/MetaCPAN/
%{_mandir}/man3/MetaCPAN::API::Tiny.3*

%changelog
* Fri Apr 27 2018 Paul Howarth <paul@city-fan.org> - 1.150270-9
- BR: perl-generators unconditionally
- BR: perl-interpreter rather than perl

* Sun Jun  4 2017 Paul Howarth <paul@city-fan.org> - 1.150270-7
- Add ability to disable at build-time the tests that require external network
  access (--without network_tests)
- Disable network tests by default as the v0 API used by this module has gone
  away (CPAN RT#122004)
- Drop support for EOL distributions prior to F-13
  - Drop BuildRoot: and Group: tags
  - Drop explicit buildroot cleaning in %%install section
  - Drop explicit %%clean section

* Sun Sep  4 2016 Paul Howarth <paul@city-fan.org> - 1.150270-5
- BR: perl-generators where available
- Simplify find command using -delete

* Wed Jan 28 2015 Paul Howarth <paul@city-fan.org> - 1.150270-1
- Update to 1.150270
  - This module is now marked as deprecated (use MetaCPAN::Client instead)
- This release by JLUIS → update source URL

* Mon Jan 26 2015 Paul Howarth <paul@city-fan.org> - 1.131730-6
- Add spec file boilerplate needed for builds on old distributions

* Thu Aug 28 2014 Paul Howarth <paul@city-fan.org> - 1.131730-5
- Use %%license where possible

* Thu Feb  6 2014 Paul Howarth <paul@city-fan.org> - 1.131730-1
- Initial RPM version
